#ifndef H_HTTP
#define H_HTTP

/* Supported Methods - sorta */
#define METHODS 		8
#define M_GET 			0
#define M_HEAD			1
#define M_POST 		 	2
#define M_PUT 			3
#define M_DELETE 		4
#define M_SECURE		5
#define M_INVALID              -1

/* Unsupported Methods */
#define M_LINK			6
#define M_UNLINK		7
#define M_OPTIONS		8
#define M_PATCH			9
#define M_COPY			10
#define M_MOVE			11
#define M_TRACE			12
#define M_WRAPPED		13

#define HEAD_UNKNOWN    0
#define HEAD_REFER      1
#define HEAD_CONNECT    2
#define HEAD_UAGENT     3
#define HEAD_HOST       4
#define HEAD_ACCEPT     5
#define HEAD_ACCENC     6
#define HEAD_ACCLAN     7
#define HEAD_ACCCHAR    8
#define HEAD_CONTTYPE   9
#define HEAD_CONTLEN    10

#define HEAD_MAX        10

#define STARTIN "a:\\ethernet\\www"
#define DEFAULT_PAGE "\\index.htm"

/* Reason (result) codes*/
#define HTTP_VER "HTTP/1.0 "

#define REA_OK          "200 OK"
#define REA_CREATE      "201 Created"
#define REA_ACC         "202 Accepted"
#define REA_NOC         "204 No Content"
#define REA_PMOVE       "301 Moved Permenently"
#define REA_TMOVE       "302 Moved Temoporarily"
#define REA_MOMOD       "304 Not Modified"
#define REA_BAD         "400 Bad Request"
#define REA_UNA         "401 Unauthorized"
#define REA_FOR         "403 Forbidden"
#define REA_NOTFOUND    "404 Not Found"
#define REA_SERV        "500 Internal Server Error"
#define REA_NOTIMP      "501 Not Implemented"
#define REA_UNAVAIL     "503 Service Unavailable"

#define CR              0x0d
#define LF              0x0a

/*    Deamon states  */

enum { IdleStartListen, IdleWaitConnect, IdleRead, RecordGet, RecordPut, XmitInProgress, WaitClose0, WaitClose1, RpStartListen, RpWaitConnect };


typedef struct rholder {
    unsigned long   RequestingIP;
    struct rholder  *NextRequest;
    char            Method;
    char            FileType;
    char            *body;
    char            KeepAlive;
    char            FilePath[200];
    char            *HeaderLines[100];
    char            RequestBuffer[4096];
    char            ResponseBuffer[200];
} REQUEST;

 /* function prototypes */

//extern int netlisten(tcp_Socket *theSocket, uint Port);
//extern int netsegsize(int newsize);
//extern void optparse();
//extern void printuse();

// Public Variables

extern unsigned char debugMode;
extern unsigned char notFoundPage;
extern unsigned char TsSbc;       // Indicate NOT Technologic Systems SBC


#endif
